#!/bin/sh

Id_file="\$Id: backupshak.sh_v 1.14 1996/05/27 04:56:17 jhl Exp $"

IDSTRING="$Id_file"

#
# If you want to modify this program to backup other files
# modify the BACKUPROOT variable and FILEARGS variable.
#

FCMD="cpio -o -H crc"
BACKUPROOT=$SHAK_LIBPATH/..
FILEARGS=" \
./var \
./lib \
./etc \
./bin \
./script \
( \
-path "'\./usr/local/src/other/slackware'" -o \
-regex "'\./usr/src/.*\.o$'" \
)"
# The 4 lines above form the excluded file set.
# In this case it probably doesn't match anything and
# is shown only as an example.

#######################################################
#######################################################
#######################################################

export IDSTRING
export FILEARGS
export FCMD

# >>>----- Extraneous  Unsupported features ---------------
if [  $# -ge 1 ]; then

  if [ $1 = "sum" ]; then
     cd ${BACKUPROOT}
     find ${FILEARGS} -prune -o -print |
     ${SHAK_USERPATH}/bin/mtimefilter  "$SHAK_SHAKDATE" |
     ${SHAK_USERPATH}/bin/filesize |
     awk '{ tot = tot + $1 } END { print tot }' 
  fi

  if [ $1 = "list" ]; then
    echo "Listing files: filter date $SHAK_SHAKDATE " 1>&2
    cd ${BACKUPROOT}
    find ${FILEARGS} -prune -o -print |
    ${SHAK_USERPATH}/bin/mtimefilter  "$SHAK_SHAKDATE"
  fi

  if [ $1 = "test" ]; then
    ${SHAK_USERPATH}/trivial.sh
  fi
  exit 0
fi

# <<<<----- End of extraneous features
echo "Running backup: ${IDSTRING}" 1>&2

TMPFILE="/var/tmp/${SHAK_SHAKTYPE}${SHAK_TAPEHOST}_$$"
LOGFILE="`${SHAK_USERPATH}/header.sh "${IDSTRING}" `"
export LOGFILE
>$TMPFILE

#Determine if full backup
echo "$SHAK_SHAKDATE" | grep "1970/01/01 00:00:00" 1>/dev/null 2>&1
if [ $? -eq 0 ]; then
 fullback="1"
else
 fullback="0"
fi

# >>>-----   backup proper -----------

cd ${BACKUPROOT}

if [ $fullback -eq 1 ]; then
 find ${FILEARGS} -prune -o -print |
 ${SHAK_USERPATH}/lib/shak0_append_file ${SHAK_LOGHOST} ${LOGFILE} PIPE_IF_3ARGS |
 ${FCMD} 2>>${TMPFILE} |
 ${SHAK_REMSH} ${SHAK_TAPEHOST} "dd obs=512 of=${SHAK_TAPEDEVICE}"
else
 find ${FILEARGS} -prune -o -print |
 ${SHAK_USERPATH}/bin/mtimefilter "$SHAK_SHAKDATE" |
 ${SHAK_USERPATH}/lib/shak0_append_file ${SHAK_LOGHOST} ${LOGFILE} PIPE_IF_3ARGS |
 ${FCMD} 2>>${TMPFILE} |
 ${SHAK_REMSH} ${SHAK_TAPEHOST} "dd obs=512 of=${SHAK_TAPEDEVICE}"
fi

# <<<----- End of backup proper ----------

blocks="`${SHAK_USERPATH}/log_stderr.sh $TMPFILE`"

${SHAK_USERPATH}/footer.sh $? $blocks
retval=$?

# >>>------ Clean up --------------
/bin/rm -f $TMPFILE
exit $retval

