static char Id_mtimefilter_c[] =
"$Id: mtimefilter.c_v 1.8 1995/10/06 23:32:02 jhl Exp $";

/* 
   Copyright (C) 1995  James H. Lowe, Jr.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>

#define LINELEN 3000

time_t mkstrtime ( char * datestring, int debug );

int main (int argc, char *argv[])
{

  char line[LINELEN], datestring[LINELEN]; 
  extern char *optarg;
  extern int optind;
  int newer, c, optionerror = 0,DEBUG=0, use_ctime=0;
  time_t testtime, testtime_correction=0, filemtime, filectime;
  struct stat st;

  newer = 1;
  while ((c = getopt (argc, argv, "f:odc-:")) != EOF)
    {
      switch (c)
	{
	case 'c':    /* filter by ctime or mtime */ 
	  use_ctime = 1;
	  break;
	case 'd':    /* debug mode on */ 
	  DEBUG = 1;
	  break;
	case 'o':    /* pass older files, */ 
	  newer = 0;
	  break;
	case 'f':   /* time offset */
	  testtime_correction = atoi (optarg);
	  break;
	case '-':
          optionerror=1;
	  break;
	default:
          optionerror = 1;

	}
    }
  argv += optind;
  argc -= optind;

  if ((optionerror == 1))
    {
       fprintf (stderr, "Usage: mtimefilter [-d][-c][-o][-f[ ]seconds] [date]\n");
       fprintf (stderr, "     -c  :use ctime, not mtime (default), value in filter test.\n");
       fprintf (stderr, "     -o  :means pass older files, filter newer\n");
       fprintf (stderr, "     -f 'seconds'  :is a integer, pos or neg to add to 'date' \n");
       fprintf (stderr, "     -d  : prints the interpretation of the date string to stderr.\n");
       fprintf (stderr, "     'date'  is a date string, current time if not provided.\n");
       fprintf (stderr, "mtimefilter: invalid arguments\n");
       exit (1);
    }

  if (argc == 0)
    testtime = time ((time_t *)(NULL));
  else
    {
      if (strlen (*argv) >= LINELEN -1L) exit (1);
      strcpy (datestring, *argv);
      if ( (testtime = mkstrtime ( datestring, DEBUG )) < 0 ) {
        fprintf (stderr,"mtimefilter: mkstrtime failure ( %s ).\n", datestring );
        exit (1);
      }
    }
  
  testtime += testtime_correction;

  while (fgets (line, LINELEN - 1, stdin) != (char *) (NULL))
    {
      if (strlen (line) >= LINELEN - 2)
	{
	  fprintf (stderr, "mtimefilter: line too long : %s\n", line);
	}
      else
	{
	  if (lstat (strtok (line, "\n\r"), &st) == 0)
	    {
	      filemtime = st.st_mtime;
	      filectime = st.st_ctime;

	           if (use_ctime && (filectime < testtime) )
		     {
                      if (!newer)
		        puts (line);
		     }

		   else if (use_ctime && (filectime >= testtime) )
		     {
                      if (newer)
		        puts (line);
		     }

	   	   else if ( !use_ctime && (filemtime < testtime) )
		     {
                      if (!newer)
		        puts (line);
		     }
	   	   else if ( !use_ctime && (filemtime >= testtime) )
		     {
                      if (newer)
		        puts (line);
		     }
              }
	   else 
	     fprintf (stderr,"\nmtimefilter: lstat failed: %s\n", line);
	}
    }
  exit (0);
}

